<?php
// Encoding: UTF-8 (without BOM) (auto-detect: °°°°°)
require('_head.inc.php');

// ----- Handle form requests and status messages -----
if (UnbUi::IsFormSuccess())
{
	if ($_POST['addfileto_revisionid'])
	{
		// The new file was added to another message
		UnbSession::SetVar('SuccessMessage', 'File saved');
		if ($_POST['add_another_file'])
		{
			UnbUi::RedirectAndExit('create_file.php?addrid=' . intval($_POST['addfileto_revisionid']));
		}
		else
		{
			UnbUi::RedirectAndExit('create_message.php?drarid=' . intval($_POST['addfileto_revisionid']));
		}
	}

	UnbUi::RedirectAndExit('alter_file.php?messageid=' . UnbUi::GetFormHandler()->GetNewMessage()->GetMessageId());
}
if (UnbUi::IsFormError())
{
	UnbUi::ReportError(UnbUi::GetFormErrorMessage());
}
if ($m = UnbSession::GetVar('SuccessMessage', true))
{
	UnbUi::ReportSuccess($m);
}

$addToRevisionId = isset($_REQUEST['addrid']) ? intval($_REQUEST['addrid']) : null;

if (!UnbSession::IsLoggedIn())
{
	UnbUi::ReportError('Not logged in');
}
else
{
	if (isset($addToRevisionId))
		echo '<h1>Add a new file to a message</h1>';
	else
		echo '<h1>Create a new file</h1>';
	?>

	<?php UnbUi::BeginForm('create_file.php', true) ?>
	<?php UnbUi::FormFileAddToMsgRev($addToRevisionId) ?>

	<table cellspacing="0" class="full-width grid first-10em">
	<script type="text/javascript" src="editor-plaintype.js"></script>
	<tr>
		<td class="vspace">Upload file:</td>
		<td><?php UnbUi::MsgAttach(true) ?></td>
	</tr>
	<tr>
		<td class="vspace">Description:<br />(optional)</td>
		<td>
			<?php UnbUi::MsgContent(true, null, null, null, 'width: 45em; height: 8em;|monospace') ?>
		</td>
	</tr>
	</table>

	<a class="sectionToggle" id="tagsHeader" href="javascript:undefined">Tags</a>

	<div class="section" id="tagsDiv">
	<table cellspacing="0" class="grid first-10em">
	<tr>
		<td>Tags:</td>
		<td><?php UnbUi::MsgTags(null) ?></td>
	</tr>
	</table>
	</div>

	<?php
	if (UnbSession::IsModerator())
	{
		?>
		<a class="sectionToggle" id="msgPropsHeader" href="javascript:undefined">Message properties</a>

		<div class="section" id="msgPropsDiv">
		<table cellspacing="0" class="grid first-10em">
		<tr>
			<td class="vspace">Page name:</td>
			<td><?php UnbUi::MsgPageName() ?></td>
		</tr>
		</table>
		</div>
		<?php
	}
	?>

	<?php
	if (UnbSession::IsLoggedIn())
	{
		?>
		<a class="sectionToggle" id="msgAccessHeader" href="javascript:undefined">Message access</a>

		<div class="section" id="msgAccessDiv">
		<table cellspacing="0" class="grid first-10em">
		<tr>
			<td class="vspace">Reading allowed to:</td>
			<td><?php UnbUi::MsgReadAccessList(null, null, 'width: 20em;', 'Everybody – click here to specify users') ?></td>
		</tr>
		<tr>
			<td class="vspace">Alteration allowed to:</td>
			<td><?php UnbUi::MsgAlterAccessList(array(UnbUserKey::Moderator, UnbSession::GetSessionUserId()), null, 'width: 20em;', 'Everybody – click here to specify users') ?></td>
		</tr>
		</table>
		</div>
		<?php
	}
	?>

	<table cellspacing="0" class="grid first-10em">
	<tr>
		<td></td>
		<td colspan="2">
			<br />
			<input type="submit" class="default icon13 ok" value="Create new file" />
			&nbsp; <input type="submit" name="add_another_file" class="icon13 ok" value="Create and add another file" />
			<?php
			if (isset($addToRevisionId))
			{
				?>
				&nbsp; <a href="create_message.php?drarid=<?php echo $addToRevisionId ?>" class="buttonlike icon13 back">Back to message editor</a>
				<?php
			}
			?>
		</td>
	</tr>
	</table>
	<?php UnbUi::EndForm() ?>

	<script type="text/javascript">//<![CDATA[
	function toggleSection(id, state)
	{
		DOM.toggleClass("#" + id + "Header", "collapsed", -DOM.toggleVisible("#" + id + "Div", state));
	}

	["msgProps", "tags", "msgAccess"].each(function (id)
	{
		DOMEvents.add("#" + id + "Header", "click", function (e) { toggleSection(id); e.target.blur(); });
	});

	//$("#subjectTb").focus();
	toggleSection("msgProps");
	toggleSection("tags");
	toggleSection("msgAccess");
	//]]></script>

	<?php
}

require('_foot.inc.php');
?>