<?php
// Encoding: UTF-8 (without BOM) (auto-detect: °°°°°)
require('_head.inc.php');

// ----- Handle form requests and status messages -----
if (UnbUi::IsFormSuccess())
{
	$msg = null;
	$messageId = 0;
	$revisionId = 0;

	if (UnbUi::GetFormHandler()->GetNewMessage())
	{
		$msg = UnbUi::GetFormHandler()->GetNewMessage();
		$messageId = UnbUi::GetFormHandler()->GetNewMessage()->GetMessageId();
	}
	if (UnbUi::GetFormHandler()->GetNewMessageRevision())
	{
		$messageId = UnbUi::GetFormHandler()->GetNewMessageRevision()->GetMessageId();
		$revisionId = UnbUi::GetFormHandler()->GetNewMessageRevision()->GetMessageRevisionId();
	}
	if (UnbUi::GetFormHandler()->GetRequestedMessage())
	{
		$msg = UnbUi::GetFormHandler()->GetRequestedMessage();
		$messageId = UnbUi::GetFormHandler()->GetRequestedMessage()->GetMessageId();
	}
	if (UnbUi::GetFormHandler()->GetRequestedMessageRevision())
	{
		$messageId = UnbUi::GetFormHandler()->GetRequestedMessageRevision()->GetMessageId();
		$revisionId = UnbUi::GetFormHandler()->GetRequestedMessageRevision()->GetMessageRevisionId();
	}

	if (isset($_POST['draft']))
	{
		UnbSession::SetVar('SuccessMessage', 'Message draft saved');
		if ($revisionId > 0)
			UnbUi::RedirectAndExit('create_message.php?drarid=' . $revisionId);
		else
			UnbUi::RedirectAndExit('create_message.php?dramid=' . $messageId);
	}
	else if (isset($_POST['draft_addfile']))
	{
		UnbSession::SetVar('SuccessMessage', 'Message draft saved');
		#UnbSession::SetVar('DraftRevisionToAddFile', $revisionId);
		UnbUi::RedirectAndExit('create_file.php?addrid=' . $revisionId);
	}
	else
	{
		// Determine a good root message for the message sub-tree to redirect to
		if (!isset($msg) && $messageId)
		{
			$msg = UnbMessage::FindByMessageId($messageId);
		}
		$rootMessageId = 0;
		if (isset($msg))
		{
			$rootMessageId = $msg->GetRefDEP(7);
		}

		UnbUi::RedirectAndExit('view_message.php?messageid=' . $messageId . ($rootMessageId ? '&rootmessage=' . $rootMessageId : '') . '#message-' . $messageId);
	}
}

UnbUi::BeginReport();
if (UnbUi::IsFormError())
{
	UnbUi::ReportError(UnbUi::GetFormErrorMessage());
}
if ($m = UnbSession::GetVar('SuccessMessage', true))
{
	UnbUi::ReportSuccess($m);
}

// ----- Load the message revision -----
$alterMessageId = isset($_REQUEST['altmid']) ? intval($_REQUEST['altmid']) : null;
$alterRevisionId = isset($_REQUEST['altrid']) ? intval($_REQUEST['altrid']) : null;
// ----- Load the base message revision -----
$replyToMessageId = isset($_REQUEST['repmid']) ? intval($_REQUEST['repmid']) : null;
$replyToRevisionId = isset($_REQUEST['reprid']) ? intval($_REQUEST['reprid']) : null;
// ----- Load draft -----
$draftMessageId = isset($_REQUEST['dramid']) ? intval($_REQUEST['dramid']) : null;
$draftRevisionId = isset($_REQUEST['drarid']) ? intval($_REQUEST['drarid']) : null;

$error = false;

// Check/Try to reply to a message
if ((isset($replyToMessageId) || isset($replyToRevisionId)) &&
	!UnbUi::GetMsgRev($replyToMessageId, $replyToRevisionId, $replyToMsg, $replyToRev, $err))
{
	UnbUi::ReportError($err);
	$error = true;
}
else if (isset($replyToMsg) && !UnbUi::CanReplyMsg($replyToMsg, $replyToRev))
{
	UnbUi::ReportError('Replying to this message is not allowed.');
	$error = true;
}
// Check/Try to alter a message
else if ((isset($alterMessageId) || isset($alterRevisionId)) &&
	!UnbUi::GetMsgRev($alterMessageId, $alterRevisionId, $alterMsg, $alterRev, $err))
{
	UnbUi::ReportError($err);
	$error = true;
}
// Check/Try to continue a draft
else if ((isset($draftMessageId) || isset($draftRevisionId)) &&
	!UnbUi::GetMsgRev($draftMessageId, $draftRevisionId, $draftMsg, $draftRev, $err))
{
	UnbUi::ReportError($err);
	$error = true;
}
else if (isset($draftRev) && !$draftRev->IsDraft())
{
	UnbUi::ReportError('This is not a draft.');
	$error = true;
}
else if (isset($draftMsg) && !UnbSession::IsLoggedIn())
{
	UnbUi::ReportError('You must be logged in to continue with a draft message.');
	$error = true;
}

if (!$error)
{
	$replyMode = isset($replyToMsg);
	$alterMode = isset($alterMsg);
	$draftMode = isset($draftMsg);

	if (($replyMode ? 1 : 0) + ($alterMode ? 1 : 0) + ($draftMode ? 1 : 0) > 1)
	{
		UnbUi::ReportError('Please decide on one thing to do here.');
		$error = true;
	}
}
UnbUi::EndReport();

if (!$error)
{
	$anyMsg = $replyMode ? $replyToMsg : ($alterMode ? $alterMsg : $draftMsg);
	$anyRev = $replyMode ? $replyToRev : ($alterMode ? $alterRev : $draftRev);

	$draftAlterMode = $draftReplyMode = false;
	if ($draftMode)
	{
		$draftAlterMode = !$draftMsg->IsDraft();
		$draftReplyMode = $draftMsg->IsDraft() && $draftMsg->GetPrimaryReference() > 0;

		if ($draftReplyMode)
		{
			$replyToMsg = UnbMessage::FindByMessageId($draftMsg->GetPrimaryReference());
			$replyToRev = $replyToMsg->GetLatestRevision(UnbMessageRevisionContentLevel::Content);
		}
	}

	if ($draftAlterMode)
		echo '<h1>Alter message, continue draft</h1>';
	else if ($draftReplyMode)
		echo '<h1>Reply to a message, continue draft</h1>';
	else if ($draftMode)
		echo '<h1>Create a new message, continue draft</h1>';
	else if ($alterMode)
		echo '<h1>Alter message</h1>';
	else if ($replyMode)
		echo '<h1>Reply to a message</h1>';
	else
		echo '<h1>Create a new message</h1>';
	?>

	<?php UnbUi::BeginForm('create_message.php') ?>
	<?php if ($replyMode) UnbUi::FormReplyToMsg($replyToMsg->GetMessageId()); ?>
	<?php if ($alterMode || $draftMode) UnbUi::FormMsgRev($anyRev->GetMessageRevisionId()) ?>

	<script type="text/javascript" src="editor-plaintype.js"></script>
	<table cellspacing="0" class="full-width grid first-10em">
	<?php
	if ($replyMode || $draftReplyMode)
	{
		?>
		<tr>
			<td>Referencing:</td>
			<td>
				<?php
				echo '<a href="view_message.php?messageid=' . $replyToMsg->GetMessageId() . '">' . htmlspecialchars($replyToRev->GetSubject()) . '</a>';
				echo ' &nbsp;–&nbsp; by <strong>' . htmlspecialchars($replyToMsg->GetOwnerUser()->GetDisplayName()) . '</strong>';
				echo ' &nbsp;–&nbsp; <span title="' . UnbUi::DateTime($replyToMsg->GetCreatedTime(), true, true) . '">' . UnbUi::RelativeTime($replyToMsg->GetCreatedTime()) . '</span>';
				?>
			</td>
		</tr>
		<?php
	}
	if ($draftMode || !$alterMode || UnbUi::CanAlterMsg($alterMsg, $alterRev))
	{
		?>
		<tr>
			<td class="vspace">Subject:</td>
			<td><?php UnbUi::MsgSubject(!$alterMode && !$draftMode, $anyMsg, $anyRev, null, 'width: 45em;') ?></td>
		</tr>
		<tr>
			<td class="vspace">Content:</td>
			<td>
				<?php UnbUi::MsgContent(!$alterMode && !$draftMode, $anyMsg, $anyRev, null, 'float: left; width: 45em; margin-right: 1.5em;|monospace') ?>
				<?php UnbUi::Buttons() ?>
				<p>
				<input type="submit" name="draft_addfile" class="icon13 create" value="Add a file" />
				</p>
				<div style="clear: left;"></div>
			</td>
		</tr>
		<?php
		if (!$replyMode && isset($anyRev))
		{
			$fileIds = $anyRev->GetFileIds();
			if (count($fileIds))
			{
				echo '<tr>';
				echo '<td>Attachments:</td>';
				echo '<td>';
				foreach ($fileIds as $fileId)
				{
					$fileMsg = UnbMessage::FindByMessageId($fileId);
					$fileRev = $fileMsg->GetSearchOrLatestRevision(UnbMessageRevisionContentLevel::Content, true);

					$size = $fileRev->GetFileDataLength();
					if ($fileRev->GetContentLevel() >= UnbMessageRevisionContentLevel::Subject)
					{
						$fileName = htmlspecialchars($fileRev->GetSubject());
						if (!strlen($fileName))
							$fileName = '<em>Unnamed file</em>';
					}
					else
					{
						$fileName = '<em>File name not accessible</em>';
					}
					if ($fileRev->GetContentLevel() >= UnbMessageRevisionContentLevel::Content)
					{
						$contentType = htmlspecialchars($fileRev->GetContentType());
					}
					else
					{
						$contentType = '<em>unknown</em>';
					}

					echo '<img src="' . mimetype_icon($contentType) . '" alt="" style="vertical-align: middle; margin: -2px 5px 2px 0;" />';
					if (preg_match('~^image/~', $contentType))
						$code = '[[image:' . $fileId . ' ' . $fileName . ']]';
					else
						$code = '[[file:' . $fileId . ' ' . $fileName . ']]';

					echo '<a href="javascript:undefined" onclick="PlainTypeInsert(\'msgContentTb\', \'' . addslashes($code) . '\')">';
					echo $fileName;
					echo '</a>';
					echo ' &nbsp;–&nbsp; ' . mimetype_description($contentType) . ', ' . format_filesize($size);
					echo ' &nbsp; ';
					UnbUi::MsgRemoveFile($fileId);
					echo '<br />';
				}
				echo '</td>';
				echo '</tr>';
			}
		}

		if ($alterMode || $draftAlterMode)
		{
			?>
			<tr>
				<td class="vspace">Changes summary:</td>
				<td><?php UnbUi::MsgSummary(null, 'width: 45em;') ?></td>
			</tr>
			<?php
		}
		else
		{
			?>
			<tr>
				<td>Entry point:</td>
				<td><?php UnbUi::MsgDEP($draftMode ? $draftMsg : !isset($replyToMsg)) ?></td>
			</tr>
			<?php
		}
	}
	else if ($alterMode)   // Implies that the message cannot be altered
	{
		?>
		<tr>
			<td>Subject:</td>
			<td><?php echo htmlspecialchars($alterRev->GetSubject()) ?></td>
		</tr>
		<?php
	}
	?>
	</table>

	<a class="sectionToggle" id="tagsHeader" href="javascript:undefined">Tags</a>

	<div class="section" id="tagsDiv">
	<table cellspacing="0" class="grid first-10em">
	<tr>
		<td>Tags:</td>
		<td><?php UnbUi::MsgTags($anyRev) ?></td>
	</tr>
	</table>
	</div>

	<?php
	if (UnbSession::IsModerator())
	{
		?>
		<a class="sectionToggle" id="msgPropsHeader" href="javascript:undefined">Message properties</a>

		<div class="section" id="msgPropsDiv">
		<table cellspacing="0" class="grid first-10em">
		<tr>
			<td class="vspace">Page name:</td>
			<td><?php UnbUi::MsgPageName($alterMsg) ?></td>
		</tr>
		<?php
		if ($alterMode || $draftAlterMode)   // Same condition as above for Entry Point
		{
			?>
			<tr>
				<td>Entry point:</td>
				<td><?php UnbUi::MsgDEP($anyMsg) ?></td>
			</tr>
			<?php
		}
		?>
		</table>
		</div>

		<a class="sectionToggle" id="msgModerationHeader" href="javascript:undefined">Message moderation</a>

		<div class="section" id="msgModerationDiv">
		<table cellspacing="0" class="grid first-10em">
		<tr>
			<td>Message moderation:</td>
			<td><?php UnbUi::MsgModerateMsg($alterMsg) ?></td>
		</tr>
		</table>
		</div>
		<?php
	}
	?>

	<?php
	if (UnbSession::IsLoggedIn() &&
		((!$alterMode && !$draftMode) || (UnbSession::IsAdministrator() || UnbUi::IsMsgOwner($anyMsg))))
	{
		$readAccessData = $replyAccessData = null;
		$alterAccessData = array(UnbUserKey::Moderator, UnbSession::GetSessionUserId());

		if ($alterMode)
		{
			$readAccessData = $alterMsg;
			$alterAccessData = $alterMsg;
			$replyAccessData = $alterMsg;
		}
		else if ($draftMode)
		{
			$readAccessData = $draftMsg;
			$alterAccessData = $draftMsg;
			$replyAccessData = $draftMsg;
		}
		?>
		<a class="sectionToggle" id="msgAccessHeader" href="javascript:undefined">Message access</a>

		<div class="section" id="msgAccessDiv">
		<table cellspacing="0" class="grid first-10em">
		<tr>
			<td class="vspace">Reading allowed to:</td>
			<td><?php UnbUi::MsgReadAccessList($readAccessData, null, 'width: 20em;', 'Everybody – click here to specify users') ?></td>
		</tr>
		<tr>
			<td class="vspace">Alteration allowed to:</td>
			<td><?php UnbUi::MsgAlterAccessList($alterAccessData, null, 'width: 20em;', 'Everybody – click here to specify users') ?></td>
		</tr>
		<tr>
			<td class="vspace">Replying allowed to:</td>
			<td><?php UnbUi::MsgReplyAccessList($replyAccessData, null, 'width: 20em;', 'Everybody – click here to specify users') ?></td>
		</tr>
		</table>
		</div>
		<?php
	}
	?>

	<?php
	if (!UnbSession::IsLoggedIn())
	{
		?>
		<input type="hidden" name="action[]" value="login" />
		<input type="hidden" name="implicit_register" value="1" />

		<h2>Register a new account</h2>

		<p>
		You are not currently logged in to write this message. In order to submit a message, you must be logged in or register an account. To register, please enter your name in the field below. After your message has been submitted, you are persistently logged in with your newly registered account. You can set a login name and a password for your account then to be able to use it from other computers.
		</p>

		<p class="warningbox">
		<strong>Attention:</strong> After this registration, you are logged in with a cookie. You cannot log in with a username and password after logout or on another computer until you set them in your account control. If you log out before, you permanently <strong>lose access</strong> to your new account! You may wish to not post now if you are on a public computer.
		</p>

		<table cellspacing="0" class="grid first-10em">
		<tr>
			<td class="vspace">Your name:</td>
			<td><?php UnbUi::UserDisplayName() ?></td>
			<td class="form-description">This name will be displayed above your messages. It is independent from your login name.</td>
		</tr>
		<?php
		if (UnbUi::IsCaptchaEnabled())
		{
			?>
			<tr>
				<td>Validation:</td>
				<td><?php UnbUi::Captcha() ?></td>
				<td class="form-description">You are asked to perform this small test to prove that you are a human and not a spam robot. <a href="http://en.wikipedia.org/wiki/CAPTCHA">More information...</a></td>
			</tr>
			<?php
		}
		?>
		</table>
		<?php
	}
	?>

	<table cellspacing="0" class="full-width grid first-10em">
	<tr>
		<td></td>
		<td colspan="2">
			<br />
			<?php
			if (UnbSession::IsLoggedIn())
			{
				if ($alterMode || $draftAlterMode)
					$label = 'Save changes';
				else if ($replyMode || $draftReplyMode)
					$label = 'Create reply message';
				else
					$label = 'Create new message';
			}
			else
			{
				// No draft mode here
				if ($alterMode)
					$label = 'Register account and save changes';
				else if ($replyMode)
					$label = 'Register account and create reply message';
				else
					$label = 'Register account and create new message';
			}
			?>
			<input type="submit" class="default icon13 ok" value="<?php echo $label ?>" />
			&nbsp; <input type="submit" name="draft" class="icon13 draft" value="Save as draft" />
			<?php
			if ($alterMode || $draftAlterMode)
			{
				?>
				&nbsp; <a href="view_message.php?messageid=<?php echo $anyMsg->GetMessageId() ?>#message-<?php echo $anyMsg->GetMessageId() ?>" class="buttonlike icon13 back">Back to message view</a>
				<?php
			}
			if ($replyMode || $draftReplyMode)
			{
				?>
				&nbsp; <a href="view_message.php?messageid=<?php echo $replyToMsg->GetMessageId() ?>#message-<?php echo $replyToMsg->GetMessageId() ?>" class="buttonlike icon13 back">Back to message view</a>
				<?php
			}
			if ($alterMode && UnbSession::IsModerator())
			{
				?>
				&nbsp; <a href="delete_message.php?messageid=<?php echo $alterMsg->GetMessageId() ?>" class="buttonlike icon13 delete">Delete this message…</a>
				<?php
			}
			// TODO: Enable deleting draft messages and message revisions
			?>
		</td>
	</tr>
	</table>
	<?php UnbUi::EndForm() ?>

	<script type="text/javascript">//<![CDATA[
	function toggleSection(id, state)
	{
		DOM.toggleClass("#" + id + "Header", "collapsed", -DOM.toggleVisible("#" + id + "Div", state));
	}

	["msgProps", "tags", "msgModeration", "msgAccess"].each(function (id)
	{
		DOMEvents.add("#" + id + "Header", "click", function (e) { toggleSection(id); e.target.blur(); });
	});

	//$("#subjectTb").focus();
	toggleSection("msgProps");
	<?php
	if ($replyMode || $draftReplyMode)
	{
		?>
		toggleSection("tags");
		<?php
	}
	?>
	toggleSection("msgModeration");
	toggleSection("msgAccess");
	//]]></script>

	<?php
}

require('_foot.inc.php');
?>