<?php
// Encoding: UTF-8 (without BOM) (auto-detect: °°°°°)
require('_head.inc.php');

// ----- Handle form requests and status messages -----
if (UnbUi::IsFormSuccess())
{
	UnbSession::SetVar('SuccessMessage', 'Tag created');
	UnbUi::RedirectAndExit('list_tags.php');
}
if (UnbUi::IsFormError())
{
	UnbUi::ReportError(UnbUi::GetFormErrorMessage());
}

if (!UnbSession::IsModerator())
{
	UnbUi::ReportError('Access denied');
}
else
{
	?>
	<h1>Create a new tag</h1>

	<?php UnbUi::BeginForm() ?>
	<input type="hidden" name="action[]" value="create_tag" />

	<table cellspacing="0" class="grid first-10em">
	<tr>
		<td>Tag name:</td>
		<td><?php UnbUi::TagName() ?></td>
		<td class="form-description">This is the visible tag name.</td>
	</tr>
	<tr>
		<td>Description:</td>
		<td><?php UnbUi::TagDescription() ?></td>
		<td class="form-description">The description of this tag explains the user when and why to use it.</td>
	</tr>
	<tr>
		<td>Flags:</td>
		<td><?php UnbUi::TagFlags() ?></td>
		<td class="form-description">Flags set special tag behaviour options.</td>
	</tr>
	<tr>
		<td>Parent tag:</td>
		<td><?php UnbUi::ParentTag() ?></td>
		<td class="form-description">A tag’s parent tag is used to organise tags in a tree hierarchy. Invisible or user data tags cannot be used as a parent.</td>
	</tr>
	<?php
	if (UnbSession::IsAdministrator())
	{
		?>
		<tr>
			<td>Read access for:</td>
			<td><?php UnbUi::TagReadAccessList(null, null, '', 'Everybody – click here to specify users') ?></td>
			<td class="form-description">List of user names or keys that can read messages with this tag, one per line.</td>
		</tr>
		<tr>
			<td>Usage access for:</td>
			<td><?php UnbUi::TagUseAccessList(null, null, '', 'Everybody – click here to specify users') ?></td>
			<td class="form-description">List of user names or keys that can assign this tag to messages, one per line.</td>
		</tr>
		<?php
	}
	?>
	<tr>
		<td></td>
		<td colspan="2">
			<br />
			<input type="submit" class="default icon13 ok" value="Create tag" /> &nbsp;
			<a href="list_tags.php" class="buttonlike icon13 back">Back to tags list</a>
		</td>
	</tr>
	</table>
	<?php UnbUi::EndForm() ?>

	<script type="text/javascript">//<![CDATA[
	$("#tagNameTb").focus();
	//]]></script>

	<?php
}
require('_foot.inc.php');
?>