<?php
// Encoding: UTF-8 (without BOM) (auto-detect: °°°°°)
require('_head.inc.php');

// ----- Handle form requests and status messages -----
if (UnbUi::IsFormSuccess())
{
	$editedUser = UnbUi::GetFormHandler()->GetEditedUser();
	UnbSession::SetVar('SuccessMessage', 'User “' . $editedUser->GetDisplayNameOrId() . '” deleted');
	UnbUi::RedirectAndExit('list_users.php');
}
if (UnbUi::IsFormError())
{
	UnbUi::ReportError(UnbUi::GetFormErrorMessage());
}

// ----- Load the user -----
$user = UnbUser::FindByUserId(intval($_REQUEST['userid']));
if (!UnbSession::IsAdministrator())
{
	UnbUi::ReportError('Access denied');
}
if (!isset($user))
{
	UnbUi::ReportError('Invalid user ID');
}
else
{
	?>
	<h1>Delete user “<?php echo htmlspecialchars($user->GetDisplayNameOrId()) ?>”</h1>

	<p>
	To permanently delete this user, press the button below. A user can only be deleted if he is no owner of any message and no author of any message revision, or the deletion will fail. All VCard entries, settings and message ratings associated with this user will be deleted automatically.
	</p>

	<?php UnbUi::BeginForm() ?>
	<?php UnbUi::FormUser($user->GetUserId()) ?>
	<input type="hidden" name="action[]" value="delete_user" />

	<p>
	<input type="submit" class="default icon13 delete" value="Delete this user" /> &nbsp;
	<a href="alter_user.php?userid=<?php echo $user->GetUserId() ?>" class="buttonlike icon13 back">Back to user</a>
	</p>
	<?php UnbUi::EndForm() ?>

	<?php
}

require('_foot.inc.php');
?>