<?php
// Encoding: UTF-8 (without BOM) (auto-detect: )
define('NOHTML', 1);
require('_head.inc.php');

$messageId = isset($_REQUEST['messageid']) ? intval($_REQUEST['messageid']) : null;
$messageRevisionId = isset($_REQUEST['messagerevisionid']) ? intval($_REQUEST['messagerevisionid']) : null;
$pageName = isset($_REQUEST['pagename']) ? trim($_REQUEST['pagename']) : null;
$forImg = $_REQUEST['forimg'] ? true : false;

if (isset($messageId) || isset($messageRevisionId))
{
	if (!UnbUi::GetMsgRev($messageId, $messageRevisionId, $msg, $rev, $err))
		error($err);
}
else if (isset($pageName))
{
	$msg = UnbMessage::FindByPageName($pageName);
	if (!isset($msg))
		error('Page name not found');
	$rev = $msg->GetSearchRevision(UnbMessageRevisionContentLevel::Content);
	if (!isset($rev))
		error('Message revision not accessible');
}
else
{
	error('No message specified');
}

if ($rev->GetContentLevel() < UnbMessageRevisionContentLevel::Content)
{
	error('Message content not accessible');
}

$fileName = $rev->GetSubject();
if (!strlen($fileName))
{
	$fileName = $msg->GetPageName();
	if (!strlen($fileName))
		$fileName = 'messagedata_' . $msg->GetMessageId() . '_' . $rev->GetMessageRevisionId();
}

$contentType = $rev->GetContentType();
if (!strlen($contentType))
	$contentType = 'unknown';

header('Content-Type: ' . $contentType);
header('Content-Disposition: inline; filename="' . str_replace(array('\\', '"'), array('\\\\', '\\"'), $fileName) . '"');
echo $rev->GetFileData();


function error($text)
{
	global $forImg;

	if ($forImg)
	{
		$text = 'Error loading image: ' . $text;

		$font = 2;
		$padX = 5;
		$padY = 3;

		$width = imagefontwidth($font) * strlen($text) + 2 * $padX;
		$height = imagefontheight($font) + 1 + 2 * $padY;

		$im = imagecreatetruecolor($width, $height);
		$backColor = imagecolorallocate($im, 255, 255, 255);
		imagefill($im, 0, 0, $backColor);
		$textColor = imagecolorallocate($im, 240, 112, 0);
		imagerectangle($im, 0, 0, $width - 1, $height - 1, $textColor);
		imagestring($im, $font, $padX, $padY, $text, $textColor);
		header('Content-Type: image/png');
		imagepng($im);
		imagedestroy($im);
	}
	else
	{
		header('Content-Type: text/plain');
		echo $text;
	}
	exit();
}
?>
