<?php
// Encoding: UTF-8 (without BOM) (auto-detect: °°°°°)
require('_head.inc.php');

$showRegisterForm = $_REQUEST['allow_register'];   // If the form part was shown before then show it again

// ----- Handle form requests and status messages -----
if (UnbUi::IsFormSuccess())
{
	if (UnbUi::GetFormHandler()->GetNewUser())
		UnbSession::SetVar('SuccessMessage', 'Registration complete, logged in');
	UnbUi::RedirectAndExit('index.php');
}
if (UnbUi::IsFormError())
{
	$errorMsg = UnbUi::GetFormErrorMessage();

	if (strpos($errorMsg, '[UNB#32]') !== false)
		$showRegisterForm = true;
	else if (strpos($errorMsg, '[UNB#20]') !== false)
		UnbUi::ReportError('The specified display name is already assigned to another user. Please choose another one.');
	else if (strpos($errorMsg, '[UNB#21]') !== false)
		UnbUi::ReportError('The specified login name is already assigned to another user. Please choose another one.');
	else
		UnbUi::ReportError($errorMsg);
}

if ($showRegisterForm)
	echo '<h1>Register a new account</h1>';
else
	echo '<h1>Log in or register</h1>';
?>

<?php UnbUi::BeginForm() ?>
<input type="hidden" name="action[]" value="login" />

<p>
Your user account allows you to post and alter messages and keep your personal preferences.<br />
Enter your login name and password to log into the system or get a new account if you do not already have one.<br />
You will then be logged in automatically when you return to this site, until you explicitly log out.
</p>

<table cellspacing="0" class="grid first-10em">
<tr>
	<td class="vspace">Login name:</td>
	<td><?php UnbUi::UserLoginName(null, null, '', true, !$showRegisterForm) ?></td>
	<td class="form-description">The login name is used for logging into the system and is independent from the display name.<br />
		It should contain letters and numbers only, no special or local characters or spaces.</td>
</tr>
<tr>
	<td class="vspace">Password:</td>
	<td><?php UnbUi::UserLoginPassword() ?></td>
	<td class="form-description">Keep this password in confidence and don’t give it away to anybody.</td>
</tr>
<?php
if (!$showRegisterForm)
{
	?>
	<tr>
		<td></td>
		<td style="padding-top: 0.6em;"><input type="submit" class="default icon13 ok" name="login" value="Log in or register" /></td>
		<td></td>
	</tr>
	<?php
}
if ($showRegisterForm)
{
	?>
	<tr>
		<td colspan="3" style="padding: 1.5em 0;">
			The login name you have entered is not registered yet.<br />
			You can register a new account now. Therefore the following data is required in addition.<br />
			In case you want to re-enter your login name, <a href="login.php">click here to try again</a>.
		</td>
	</tr>
	<tr>
		<td class="vspace">Repeat password:</td>
		<td><?php UnbUi::UserRepeatPassword() ?></td>
		<td class="form-description">To avoid typing errors, enter the password for a second time.</td>
	</tr>
	<tr>
		<td class="vspace">Display name:</td>
		<td><?php UnbUi::UserDisplayName() ?> &nbsp; <small class="light">optional</small></td>
		<td class="form-description">This name will be displayed above your messages. If you leave it empty, your login name will be used.</td>
	</tr>
	<?php
	if (UnbUi::IsCaptchaEnabled())
	{
		?>
		<tr>
			<td>Validation:</td>
			<td><?php UnbUi::Captcha() ?></td>
			<td class="form-description">You are asked to perform this small test to prove that you are a human and not a robot. <a href="http://en.wikipedia.org/wiki/CAPTCHA">More information...</a></td>
		</tr>
		<?php
	}
	?>
	</table>

	<h2>Terms of use</h2>

	<p>
	(Some legal stuff to scare away the users...)
	</p>

	<h2>Moderation process</h2>

	<p>
	The new account is enabled from the beginning and can be used to post messages. Unvalidated users will be moderated though, i.e. new messages will only be published after a moderator has reviewed them. This moderation can be avoided by validating your identity. Although the moderators try to review messages promptly, no guarantee can be given regarding the moderation time.
	</p>

	<table cellspacing="0" class="grid first-10em">
	<tr>
		<td></td>
		<td style="padding-top: 0.6em;"><input type="submit" class="default icon13 ok" name="allow_register" value="Register account and log in" /></td>
		<td></td>
	</tr>
	<?php
}
?>
</table>
<?php UnbUi::EndForm() ?>

<script type="text/javascript">//<![CDATA[
<?php
if ($showRegisterForm)
{
	?>
	$("#userRepeatPasswordTb").focus();
	<?php
}
else
{
	?>
	$("#userLoginNameTb").focus();
	<?php
}
?>
//]]></script>

<?php
require('_foot.inc.php');
?>